#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <bios.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#define STATUSP 0    /* print byte */
#define STATUSS 2    /* check status */
void main(argc,argv)
int argc;
char **argv;
{
   FILE *stream;
   char fname[80];
   char ch;
   int status, abyte=0, handle;
   long ctr=0,flength;
   int portn=0;
   printf("SLOWPRNT: Slows Printing\n");
   printf("Copyright (c) 1992,1993 by Jonas Roco, Olympia, WA  All rights reserved.\n");
   if (argc < 2)
   {
       printf("\n");
       printf("Usage: slowprnt [filename] [portnumber]\n");
       printf("\n");
       printf("When using older printers with Windows running on fast 386 or 486\n");
       printf("CPU's with caching, print jobs can loose data or occasionally stutter \n");
       printf("because of their inability to print when recieving data at a high\n");
       printf("rate of speed.  This causes gaps in the print job, particularly when\n");
       printf("printing graphics that make the printout look like the printer decided \n");
       printf("to insert a few spaces here and there.  This was the case with my \n");
       printf("ancient trusty Epson MX-80 when I upgraded to a 386/40 with 64k of cache.  \n");
       printf("Refusing to give the printer up, I wrote this utility.\n");
       printf("\n");
       printf("If using Windows, setup the printer configuration to print to a file\n");
       printf("instead of a printer port.  After printing, run SLOWPRNT to send the file \n");
       printf("to the printer.\n");
       printf("\n");
       printf("If using a regular DOS application, run one of the several programs\n");
       printf("that will capture data sent to a printer and redirect it to a file.\n");
       printf("(PRN2FILE or LPTX are two programs I have used)  Exit the application,\n");
       printf("turn off the capture program, and run SLOWPRNT to send the captured\n");
       printf("file to the printer.\n");
       printf("\n");
       printf("I disclaim any and all problems that may occur as a result of using\n");
       printf("this program nor do I guarantee anything.  Use at your own risk.  \n");
       printf("\n");
       printf("I included source to allow you to change parameters for your printer,\n");
       printf("if necessary.\n");
       printf("\n");
       printf("If you like SLOWPRNT or find yourself using it or find the source code\n");
       printf("useful, please send me $10.\n");
       printf("\n");
       printf("   Jonas Roco\n");
       printf("   7209 10th Avenue Northeast\n");
       printf("   Olympia, WA  98516");
       exit(0);
   }
   if (argc > 2)
   {
	portn=atoi(argv[2]);
	if ((portn < 1) || (portn > 3))
	{
		printf("Invalid Port: %i",portn);
		exit(2);
	}
	printf("Printing to LPT%i\n",portn);
        portn=portn-1;
   }
   strcpy(fname,argv[1]);
   /* open a file for update */
   if ((handle = open(fname, O_RDONLY )) == -1)
   {	
	printf("Cannot find file.");
	exit(2);
   }
   /* printf("file length in bytes: %ld\n",filelength(handle)); */
   flength=filelength(handle);
   close(handle);
   if ((stream = fopen(fname, "rb")) == NULL)
   {
       printf("Cannot find file.");
       exit(2);
   }
   do
   {
      /* read a char from the file */
      ch = fgetc(stream);
      abyte = ch;
      /* add delays here to slow printing between characters */
      /*     delay(50); */
      do {
	 status = biosprint(STATUSS, abyte, portn);
      } while (!(status & 0x80));
      /* print the character */
      status = biosprint(STATUSP, abyte, portn);
      /* increasing this delay will allow more time during CRs */
      if (abyte==0x0D) delay(2000);
      /*      if (ch==0x0D) delay(2000);*/
      /*      printf("%ld\n",ctr);   DEBUG info */
  } while (ctr++ < flength);
  fclose(stream);
  exit(0);
}
